/*
 * Copyright (C) 2004 Sun Microsystems, Inc. All rights reserved. Use is
 * subject to license terms.
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the Lesser GNU General Public License as
 * published by the Free Software Foundation; either version 2 of the
 * License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
 * USA.
 */ 

package com.frostwire.util.filetypes;


/**
 * An <code>AssociationAlreadyRegisteredException</code> is thrown by certain methods 
 * of <code>AssociationService</code> while trying to add an association already 
 * existed in the system.
 * 
 * @see AssociationService
 */
public class AssociationAlreadyRegisteredException extends AssociationException {
  
    private static final long serialVersionUID = -1847734591125684693L;

    /**
     * Constructs an <code>AssociationAlreadyRegisteredException</code> object
     * with no detail message.
     */
    public AssociationAlreadyRegisteredException() {
        super();
    }
  
    /**
     * Constructs an <code>AssociationAlreadyRegisteredException</code> object
     * with the specified detail message.
     * 
     * @param msg the detail message pertaining to this exception.
     */
    public AssociationAlreadyRegisteredException(String msg) {
        super(msg);
    }
}
