/*
 * Created by Angel Leon (@gubatron), Alden Torres (aldenml)
 * Copyright (c) 2011, 2012, FrostWire(TM). All rights reserved.
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

package org.limewire.util;

import java.io.BufferedReader;
import java.io.InputStream;
import java.io.InputStreamReader;

/**
 * 
 * @author gubatron
 * @author aldenml
 *
 */
public final class UnameReader {
	
	public static String read()  {
		
		String output = "";
		
		try {
		
			ProcessBuilder pb = new ProcessBuilder("uname", "-a");
			pb.redirectErrorStream(true);
			Process proc = pb.start();

			InputStream is = proc.getInputStream();
			InputStreamReader isr = new InputStreamReader(is);
			BufferedReader br = new BufferedReader(isr);

			String line;
			int exit = -1;

			while ((line = br.readLine()) != null) {
			    
				output = line;
			    
			    try {
			        exit = proc.exitValue();
			        if (exit == 0)  {
			            // Process finished
			        }
			    } catch (IllegalThreadStateException t) {
			        proc.destroy();
			    }
			}
		} catch (Exception e) {
		    // ignore
		}
		
		return output;
	}
}
