/**
 * Copyright (c) 2009 - 2011 AppWork UG(haftungsbeschränkt) <e-mail@appwork.org>
 * 
 * This file is part of org.appwork.storage.config
 * 
 * This software is licensed under the Artistic License 2.0,
 * see the LICENSE file or http://www.opensource.org/licenses/artistic-license-2.0.php
 * for details
 */
package org.appwork.storage.config.handler;

import java.lang.annotation.Annotation;

import org.appwork.storage.config.annotations.DefaultFloatValue;

/**
 * @author Thomas
 * 
 */
public class FloatKeyHandler extends KeyHandler<Float> {

    /**
     * @param storageHandler
     * @param key
     */
    public FloatKeyHandler(final StorageHandler<?> storageHandler, final String key) {
        super(storageHandler, key);
        // TODO Auto-generated constructor stub
    }

    @Override
    protected Class<? extends Annotation> getDefaultAnnotation() {

        return DefaultFloatValue.class;
    }

    @Override
    protected void initDefaults() throws Throwable {
        this.setDefaultValue(0f);
    }

    /*
     * (non-Javadoc)
     * 
     * @see org.appwork.storage.config.KeyHandler#initHandler()
     */
    @Override
    protected void initHandler() {
        try {
            this.setDefaultValue(this.getAnnotation(DefaultFloatValue.class).value());
        } catch (final NullPointerException e) {
            this.setDefaultValue(0f);
        }
    }

    /*
     * (non-Javadoc)
     * 
     * @see org.appwork.storage.config.KeyHandler#putValue(java.lang.Object)
     */
    @Override
    protected void putValue(final Float object) {

        this.storageHandler.putPrimitive(this.setter.getKey(), object);

    }

    /*
     * (non-Javadoc)
     * 
     * @see
     * org.appwork.storage.config.KeyHandler#validateValue(java.lang.Object)
     */
    @Override
    protected void validateValue(final Float object) throws Throwable {
        // TODO Auto-generated method stub

    }

}
