'''
This script will pack200 all the jars available on this folder.
'''
import os
import sys

def pack200(effort=4,packPropertiesDir='.'):
    pack200options=' '.join(["--effort="+str(effort),
                             "--no-gzip",
                             "--strip-debug",
                             '--deflate-hint="false"',
                             "--modification-time=latest",
                             #"--segment-limit=-1",
                             "--no-keep-file-order",
                             "--config-file="+packPropertiesDir+os.sep+"pack.properties"
                             ])
    localFiles = os.listdir(".")
    for f in localFiles:
        if f.endswith('.jar'):
            print "Packing200 ", f
            file_name_no_ext = f[0:f.find('.jar')]

            #if we're on mac osx, force pack200 from Java 1.5.0
            pathToPack200='/System/Library/Frameworks/JavaVM.framework/Versions/1.5.0/Commands'

            #find valid path where pack200 is contained
            if os.uname()[0].lower() == 'linux':
                pathToPack200=os.popen('which pack200').readline().strip().replace('/pack200','')

            pack200cmd = "%s/pack200 %s %s %s" % (pathToPack200,
                                                  pack200options,
                                                  file_name_no_ext+'.pack',#packed file name
                                                  f) #original jar file name

            os.system(pack200cmd)
    return

if __name__ == "__main__":
    dir='.'
    if len(sys.argv)==2:
        dir=sys.argv[1]
    pack200(packPropertiesDir=dir)
